(define-module (ui pve ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :export (init))

(define *parameters* '())
(define *in-cluster* #f)
(define *cluster-run* #f)
(define *cluster-name* "unknown")
(define *cluster-status* "unknown")
(define *manager-status* "unknown")

(define (ui-create-cluster)
  (catch/message
    (lambda ()
      (woo-write "/pve" 'cluster_name (form-value "cluster_name_edit"))
      (ui-general-read)
    )))

(define (ui-add-in-cluster) ()
   )

(define (ui-start-pve-cluster)
  (woo-new "/pve" 'pve_service "start")
)

(define (ui-general-read)
  (catch/message
    (lambda()
      (let* ((data (woo-read "/pve")))
        (set! *in-cluster* (woo-get-option (car data) 'in_cluster))
        (set! *cluster-run* (woo-get-option (car data) 'cluster_run))
        (set! *cluster-name* (woo-get-option (car data) 'cluster_name))
        (set! *cluster-status* (woo-get-option (car data) 'pve_cluster_status))
        (set! *manager-status* (woo-get-option (car data) 'pve_manager_status))
	)
      (form-update-visibility "start_pve_cluster" (not *cluster-run*))
      (form-update-visibility "cluster_name_edit" (and (not *in-cluster*) *cluster-run*))
      (form-update-visibility "cluster_name" (and *in-cluster* *cluster-run*))
      (form-update-visibility "pve_cluster_status" (and *in-cluster* *cluster-run*))
      (form-update-visibility "pve_manager_status" (and *in-cluster* *cluster-run*))
      (form-update-visibility "create_cluster" (and (not *in-cluster*) *cluster-run*))
      (form-update-visibility "add_in_cluster" (and (not *in-cluster*) *cluster-run*))
      (form-update-activity "add_in_cluster" #f)
      (form-update-visibility "ssh_key" #f) ;; (not *in-cluster*))
      ;; (form-update-visibility "sshkey_algorithm" (not *in-cluster*))
      ;; (form-update-visibility "generatessh_key" (not *in-cluster*))
      ;; (form-update-value "cluster_name_edit" *cluster-name*)
      (form-update-value "cluster_name" *cluster-name*)
      (form-update-value "pve_cluster_status" *cluster-status*)
      (form-update-value "pve_manager_status" *manager-status*)))
)

(define (init)
  ;; read
  (ui-general-read)
  ;; buttons
  ;; (form-bind "create_cluster" "click" ui-create-cluster)
  (form-bind "create_cluster" "click" ui-create-cluster)
  (form-bind "add_in_cluster" "click" ui-add-in-cluster)
  (form-bind "start_pve_cluster" "click" ui-start-pve-cluster)
    )
